import string
from Products.PloneExFile import install_globals
from Products.PloneExFile import ExFile
from Products.PloneExFile.global_symbols import *
from Products.PloneExFile.Installation import Installation

fti_list = (
    ExFile.factory_type_information,
    )
fti_list2 = (
    ExFile.factory_type_information2,
    )
types_list = (
    "ExFile",
    )
skin_name = "ExFile"
i18n_name = "ExFile"

perms_list_1 = (ExFile_addPermission, ExFile_editPermission,)
perms_list_2 = (ExFile_forceUnlockPermission, )

def install(self):
    # Install properties
    if not hasattr(self.portal_properties, 'ploneexfile_properties'):
        self.portal_properties.addPropertySheet('ploneexfile_properties', 'PloneExFile properties')
    
    props = self.portal_properties.ploneexfile_properties
    
    if not hasattr(props, 'use_lock'):
        props._setProperty('use_lock', 0, 'boolean')
    
    if not hasattr(props, 'show_smallpreview'):    
        props._setProperty('show_smallpreview', 0, 'boolean')
    
    installation=Installation(self)
    installation.setPermissions(perms_list_1)
    installation.setPermissions(perms_list_2, roles = ['Manager',])
    installation.setupTypesandSkins(fti_list, skin_name, install_globals, fti_list2)
    for ctype in types_list:
        validation = [
              ('%s_editForm' % (ctype), 'validate_id,validate_%s_edit' % ctype, ),
              ]
        installation.addFormValidators(validation)
        lowertype=ctype.lower()
        transitions = [
              ('%s.%s_editForm.success' % (lowertype, ctype ), 'script:%s_edit' % (ctype), ),
              ('%s.%s_editForm.failure' % (lowertype, ctype ), '%s_editForm' % (ctype), ),
              ('%s.%s_edit.success' % (lowertype, ctype ), 'action:view', ),
              ('%s.%s_edit.failure' % (lowertype, ctype ), 'action:edit', ),
              ]
        installation.addNavigationTransitions(transitions)
        installation.addActionIcon(category='plone',
                                   action_id='unlock_lock',
                                   icon_expr='lock.gif',
                                   title="Lock (Currently not locked)",
                                   priority=0)
        installation.addActionIcon(category='plone',
                                   action_id='lock_unlock',
                                   icon_expr='unlock.gif',
                                   title="Unlock (Currently locked)",
                                   priority=0)
      
    return installation.report()
